#ifndef YumIOCapturersMinion_h
#define YumIOCapturersMinion_h

#include <QtCore/QObject>
#include <QtCore/QSocketNotifier>
#include <QtCore/QSemaphore>

class YumIO;

class YumIOCapturersMinion : public QObject
{
   Q_OBJECT
public:
   explicit YumIOCapturersMinion(YumIO*  yumIO,
                                 int     stdoutReadFd,
                                 int     stderrReadFd);
   ~YumIOCapturersMinion();
protected slots:
   void  initialize();
   void  finalize();
public:
   void  activate();
   void  deactivate();
public:
   void  moveToThread(QThread*  targetThread);
protected slots:
   void  readStdout ();
   void  readStderr ();
protected:
   YumIO*  yumIO;
protected:
   bool              initialized;
   int               stdoutReadFd;
   int               stderrReadFd;
   QSocketNotifier*  stdoutReadNotifier;
   QSocketNotifier*  stderrReadNotifier;
   QSemaphore        finalizeCompleted;
};

#endif
